/*
 * detok: Detokenise a C token file into something a programmer can read.
 * Copyright (c) Warren Toomey, under the GPL license.
 * 
 * $Revision: 1.15 $
 */
#include <sys/types.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include "tokens.h"

int main(int argc, char *argv[])
{
  unsigned int ch, linenum = 0;
  uint32_t val;
  FILE *zin;
  char **name;
  uint32_t offset;

  if (argc != 2) {
    fprintf(stderr, "Usage: detok cft_file\n");
    exit(1);
  }
  zin = ctfopen(argv[1]);

  /* Initialise the name and offsets to after the header */
  name = (char **)malloc(sizeof(char *));
  offset = ftell(zin);

  /* While there is a token to be found */
  while ((ch = get_token(zin, &offset, &val, name)) != 0) {
    switch (ch) {
    case FILENAME:
      linenum = 1;
      break;
    case LINE:
      linenum++;
    }
    print_token(ch, linenum, val, *name);
  }
  exit(0);
}
